<%--
 * Component: dotcom
 *
 * Description:
 *      Deletes a study or part of a study from the HUB server when user is logged to the CWL server
 *
 * Parameters:
 * 
 *       cStudy   : Study Instance UID of the study/studies to be deleted
 *       cUser    : User initiating delete
 *       cOper    : 'Del' for delete study, 'Check' for check if study is deletable
 *       cForce   : Force delete - for studies not yet sent to insite archive
 *       cRule    : rule(s) for delete only a part of a study
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="java.util.*, 
			imagemed.jsputil.StudyToolbox, imagemed.imsession.*, imagemed.dotcom.*, imagemed.dcprocessing.StudyRemover"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession(request, response, out);

	response.setContentType("text/plain");

	try {
		// Check if peer is the parent server
		Properties prpPeer = imagemed.jsputil.DotcomToolbox.checkClient(is, "P", false);
		if (prpPeer != null) {
			String deviceID = prpPeer.getProperty("ID","");
			if ("".equals(deviceID)) {
				throw new Throwable();
			}

			// Accept request only if parent is a CWL server
			if (!DotcomConfig.isParentDbOnly())
				throw new Throwable();
		}
	}
	catch (Throwable th) {
		out.println("ERROR: Unauthorized peer");
		return;
	}

	String[] parStudies = request.getParameterValues("cStudy");
	String parUser = request.getParameter("cUser");
	String parOper = request.getParameter("cOper");
	boolean doForce = "true".equals(request.getParameter("cForce"));
	String[] parRules = request.getParameterValues("cRule");
	boolean invalidate = "true".equals( request.getParameter( "cInvalidate" ) );

	if (parStudies == null || parStudies.length == 0) {
		out.println("ERROR: Missing parameter: cStudy");
		return;
	}

	if (parOper == null) {
		out.println("ERROR: Missing parameter: cOper");
		return;
	}


	if ("Check".equals(parOper)) {
		// check if studies are deletable

		for (int i = 0; i < parStudies.length; i++) {
			if (StudyRemover.DELETABLE_NONE == StudyRemover.isStudyRemovable(parStudies[i],false)) {
				out.println("STUDY-OK: " + parStudies[i]);
			}
			else {
				out.println("STUDY-NR: " + parStudies[i]);
			}
		}
	}
	else if ("Del".equals(parOper)) {
		// Perform delete
		List<String> rules = null;
		if (parRules != null && parRules.length > 0) {
			rules = Arrays.asList(parRules);
		}

		StudyToolbox.deleteStudies(parStudies, parUser, doForce, rules, invalidate);
	}
	else {
		out.println("ERROR: Bad arguments");
		return;
	}

	out.println("#RESULT: OK");
%>
