<%--
 * Component: dotcom
 *
 * Description:
 *  Proliferates files in dotcom
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.util.*,java.util.*,imagemed.imsession.*,java.io.*,imagemed.jsputil.DotcomToolbox"

%><%!

	long parseTime(String strTime) {
		long returnValue = 0;
		try {
			int year = Integer.parseInt(strTime.substring(0,4));
			int month = Integer.parseInt(strTime.substring(4,6)) - 1;
			int day = Integer.parseInt(strTime.substring(6,8));
			int hour = Integer.parseInt(strTime.substring(8,10));
			int min = Integer.parseInt(strTime.substring(10,12));
			int sec = Integer.parseInt(strTime.substring(12,14));

			returnValue = new GregorianCalendar(year,month,day,hour,min,sec).getTime().getTime();
		}
		catch (Throwable th) {
		}

		return returnValue == 0 ? System.currentTimeMillis() : returnValue;
	}


	String[] createCmd(String strScript, String strParams, String filename) {
		if (strParams == null) {
			String[] strCmdArray = new String[3];
			strCmdArray[0] = strScript;
			strCmdArray[1] = "-f";
			strCmdArray[2] = filename;
			return strCmdArray;
		}

		StringTokenizer st = new StringTokenizer(Helper.replace(strParams,"\\n","\n"),"\n");
		String[] strCmdArray = new String[st.countTokens() + 3];
		strCmdArray[0] = strScript;
		strCmdArray[1] = "-f";
		strCmdArray[2] = filename;
		int i = 3;

		while (st.hasMoreTokens()) {
			strCmdArray[i++] = st.nextToken();
		}

		return strCmdArray;
	}

%><%
	IMSession is = new IMSession(request, response, out);

	MultipartParser mpParams = new MultipartParser(is,IMEnvBase.getEnv("TMP"));

	String parDestFileName = mpParams.getParameter("cName");
	String parTmpFileName  = mpParams.getParameter("cFile");
	String parFileTime     = mpParams.getParameter("cDate");
	String parScript       = mpParams.getParameter("cScript");
	String parParams       = mpParams.getParameter("cParams");

	String strDestFileName = parDestFileName;
	if (parDestFileName != null && !parDestFileName.startsWith("/"))
		strDestFileName = IMEnvBase.getEnv("HOME") + "/" + parDestFileName;

	String strScript = parScript;
	if (parScript != null && !parScript.startsWith("/"))
		strScript = IMEnvBase.getEnv("HOME") + "/" + parScript;

	String devID = null;
	try {
		Properties devPrp = DotcomToolbox.checkClient( is, "PCS", false );
		devID = devPrp.getProperty("ID");
	}
	catch (Throwable th) {
		Helper.ERRORLOG( "proliferate", "Exception while checking peer: " + Helper.throwable2String( th ) );
	}
	
	String exceptParam = devID == null ? "-x\\n" + request.getRemoteAddr() : "-x\\n" + devID;
	if (parParams == null)
		parParams = exceptParam;
	else
		parParams = parParams + "\\n" + exceptParam;

	boolean bSucceed = false;
	boolean bNewer = false;
	boolean bSaved = false;

	File fileTmp = null;
	File fileDest = null;
	File fileSave = File.createTempFile("proliferate","save", new File(IMEnvBase.getEnv("TMP")));

	Syslog logger = new Syslog("proliferate.jsp", 0, IMEnvBase.getEnv("LOG_FACILITY"));
	logger.syslog(Syslog.LOG_INFO, strDestFileName + " received " +
				strDestFileName + " " + parTmpFileName + " " + parFileTime + " " + strScript
				+ " " + parParams);

	try {
		fileDest = new File(strDestFileName);
		if (parTmpFileName == null)
			throw new Throwable("strFileNotFound");

		fileTmp = new File(parTmpFileName);
		String strFileNotFound = "[File wasn't found by client]";
		byte[] buffer = new byte[strFileNotFound.length()];

		FileInputStream fisTmp = new FileInputStream(fileTmp);
		int nRead = fisTmp.read(buffer);
		fisTmp.close();

		if (nRead > 0) { // File is not empty
			if (strFileNotFound.startsWith(new String(buffer,0,nRead))) {
				fileSave.delete();
				throw new Throwable("strFileNotFound");
			}
		}

		// check if fileDest time is newer than parFileTime
		long lFileTime = parseTime(parFileTime);
		if (fileDest.exists() && lFileTime <= fileDest.lastModified()) {
			bNewer = true;
			fileSave.delete();
			throw new Throwable("Newer");
		}

		if (fileDest.exists()) {
			bSaved = ( Helper.renameToNotThrowsException( fileDest, fileSave ) );
		}
		
		int pos = strDestFileName.lastIndexOf("/");
		if (pos != -1) {
			try {
				String destDirName = strDestFileName.substring(0,pos);
				File destDir = new File(destDirName);
				if (!destDir.exists())
					destDir.mkdirs();
			}
			catch(Throwable th) {
			}
		}

		fileTmp.setLastModified(lFileTime);
		if ( Helper.renameToNotThrowsException( fileTmp, fileDest ) ) {
			if (strScript != null) {
				String cmd[] = createCmd(strScript, parParams, strDestFileName);
				String env[] = new String[1];
				env[0] = "HOME=" + IMEnvBase.getEnv("HOME");

				String strCmd = "";
				for (int i = 0; i < cmd.length; i++)
					strCmd = strCmd + " | " + cmd[i];

				logger.syslog(Syslog.LOG_INFO,strDestFileName + " run command: " + strCmd);

				RunCommandResult res = Helper.runCommandEx(cmd,env);
				if (res.getExitCode() != 0)
					throw new Throwable("Script failed");
			}
			bSucceed = true;
			fileSave.delete();
		}
	}
	catch (Throwable th) {
		if ("strFileNotFound".equals(th.getMessage())) {
			try {
				Helper.writeTextFile(strDestFileName, null);

				fileSave.delete();

				String cmd[] = createCmd(strScript, parParams, strDestFileName);
				String env[] = new String[1];
				env[0] = "HOME=" + IMEnvBase.getEnv("HOME");

				String strCmd = "";
				for (int i = 0; i < cmd.length; i++)
					strCmd = strCmd + " | " + cmd[i];

				logger.syslog(Syslog.LOG_INFO,strDestFileName + " run command: " + strCmd);

				RunCommandResult res = Helper.runCommandEx(cmd,env);
				if (res.getExitCode() != 0)
					throw new Throwable("Script failed");
				bSucceed = true;
			}
			catch(Throwable th2) {
			}
		}
	}

	if (!bSucceed) {
		if (bSaved){
			Helper.renameToNotThrowsException( fileSave, fileDest );
		}
		if (fileTmp != null)
			fileTmp.delete();
	}

%><%= bSucceed ? "OK" : (bNewer ? "NEWER" : "FAILED") %>
